// This file is part of noxos and licensed under the MIT open source license

#ifndef LIBNX_STDIO_H
#define LIBNX_STDIO_H

#include "public/nox/stdtypes.h"
#include "public/nox/string.h"

typedef struct file_T file_T;

file_T      file_open       (string_t path);
void        file_close      (file_T* file);
uint64_t    file_read       (file_T* file, void* buffer, uint64_t n);
uint64_t    file_write      (file_T* file, void* buffer, uint64_t n);
uint64_t    file_cursor_get (file_T* file);
void        file_cursor_set (file_T* file, uint64_t cursor);

#endif //LIBNX_STDIO_H
