// This file is part of noxos and licensed under the MIT open source license

#include "public/nox/string.h"

uint64_t strlen(string_t str) {
    uint64_t n = 0;
    while (str[n++]);
    return n;
}

uint64_t str2int(string_t str, uint32_t base, uint64_t* len) {
    uint64_t num = 0;

    while (is_numeric(*str)) {
        num *= base;
        num += *str - '0';

        str++;
        if (len != NULL) *len += 1;
    }

    return num;
}

bool is_numeric(char chr) {
    return (chr >= '0' && chr <= '9');
}

bool is_lower(char chr) {
    return (chr >= 'a' && chr <= 'z');
}

bool is_upper(char chr) {
    return (chr >= 'A' && chr <= 'Z');
}

bool is_special(char chr) {
    return ((chr >= '!' && chr <= '/') ||
            (chr >= ':' && chr <= '@') ||
            (chr >= '[' && chr <= '`') ||
            (chr >= '{' && chr <= '~'));
}